#include <termios.h>
#include <unistd.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#define TRUE 1
#define FALSE 0

#define NB_CARACTERES 20	// taille de la lignes
#define TIME_TO_WAIT 60000	// temps d'attente

typedef struct termios termios;
static void handler();
static int test;

void my_printf(char chaine)
{
	printf("%c",chaine);
	fflush(stdout);
	usleep(TIME_TO_WAIT);
}

/*
	affiche les crochets
*/
void prepareAffichage()
{
	int i;
	printf("[");
	for(i=0; i<NB_CARACTERES; i++)
		printf(" ");
	printf("]\b");
	for(i=0; i<NB_CARACTERES; i++)
		printf("\b");
}


int pong(char argv)
{

	int j, i;
	
		// affiche les crochets
		prepareAffichage();
		// Allez
		for(i=0; i<NB_CARACTERES; i++)
			my_printf(argv);
			my_printf(']');
		// Retour
		for(i=0; i<NB_CARACTERES; i++)
		{
			printf("%c",'\b');
			printf("%c",'\b');
			my_printf(' ');
		}
		printf("\b\b");

	return 0;
}


void handler()
{
		test=1;
		return;
}

int main()
{
	
	termios t_save, t_new;
	struct sigaction action;
	test=0;
	if( tcgetattr(0, &t_save) )
	{
		printf("Erreur de tcgetattr !\n");
		exit(1);
	}

	// initialisation
	t_new = t_save;
	t_new.c_lflag &= (~ICANON & ~ECHO);
	t_new.c_cc[VMIN]= 1;

	tcsetattr(0, TCSANOW, &t_new);
	int quit = FALSE,car;
	int n;
	int pfd[2];
	pipe(pfd);
	n=fork();
	//char * lecture;
	char lecture;
	char lettre='-';
	int fils,statut;
	if(n==0)  //dans le fils
	{
		while(1)
		{
			close(pfd[1]);
			action.sa_handler = handler;
			sigaction(SIGUSR1, &action, NULL);
			if(test==1)
			{
				read(pfd[0],&lecture,1);
				lettre=lecture;
				test=0;
			}
			pong(lettre);
			if (lettre=='f')
			{
				printf("fin du fils\n");
				exit(1);
			}
		}

	}
	else		//dans le pere
	{
		close(pfd[0]);
		while(!quit)
		{
			car = getchar();
			write(pfd[1],&car,1); 
			if (car == 'f') quit = TRUE;
			kill(n,SIGUSR1);/* envoie SIGUSR1 a son fils */
		}
		fils=wait(&statut);
		if (WIFEXITED(statut))
		{
		printf("fin du pere\n");
		exit(1);
		}
	}
	tcsetattr(0, TCSANOW, &t_save);
	return 0;
}

