#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/mman.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include "header.h"



int main()
{
	int *tab;
	int lu, fd;

	// Ouverture du fichier
	fd=open(FICHIER, O_RDWR, 0666);
	if(fd == -1)
	{
		printf("Fichier non ouvert !!!\n");
		exit(1);
	}

	// On map le fichier "buffer"
	tab = mmap(NULL, BYTE_OF_BUFFER, PROT_READ,
		MAP_SHARED, fd, 0);
	if(tab == (int*)(-1))
	{
		perror("Echec du mmap");
		exit(1);
	}

	// Boucle d'opration
	do
	{
		// On slectionne l'indice o lire les donnes
		scanf("%d", &lu);
		if((lu < SIZE_OF_BUFFER) && (lu >= 0))
		{
			// Si l'indice est correcte, on affiche la valeur
			printf("%d\n", tab[lu]);
		}

	}
	while(lu != INT_EXIT);

	// Fermeture du fichier
	close(fd);
	return 0;
}	



