#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#define TAILLE 10

// Liste les lments d'un tableau d'entier
void imprime(int * tab)
{
	int i;
	for(i=0;i<TAILLE;i++)
		printf("\t%d",tab[i]);
	printf("\n");
}


int main()
{
/* Dfinition et initialisation */
	int tab1[TAILLE], tab2[TAILLE],i=0;
	struct shmid_ds buf;
	int statut;
	for(;i<TAILLE;i++)
	{
		tab1[i]=1;
		tab2[i]=1;
	}

/* Cration d'une zone de mmoire partage */
	int shmid=shmget(ftok("/volsme/users/sr02p020/TD1",78), TAILLE*sizeof(int), 0777|IPC_CREAT);
	int * buffer = shmat(shmid, NULL, 0);
	
	// initialisation de tab2
	for(i=0;i<TAILLE;i++)
		tab2[i]=2;
	imprime(tab2);

	// On copie le tableau dans la zone de mmoire partage
	memcpy(buffer, tab2, sizeof(tab2));

	// attendre 10 secondes
	usleep(10000000);

	// on supprime la zone de mm partage
	shmctl(shmid, IPC_RMID,0);
	printf("fin du fichier d'criture\n");
}
