#include "semaph.h"

static int semaph_id  = 0;
static int semaph_ini = 0;
//static struct sembuf semaph_tab;

int init_semaphore(void)
{
	if (semaph_ini == 1)//test si le smaphore existe dj
	{
		fprintf(stderr, "Err - Semaphore deja initialise!\n");
		return -1;
	}
	if (semaph_id = semget(ftok("/volsme/users/sr02p020/TD2",78),N_SEM,0600|IPC_CREAT))//cration des smaphores
	{
		semaph_ini = 1;//on met la variable static  1
		return 0;
	}
	fprintf(stderr, "Err - Impossible de creer le semaphore\n");//si cration impossible
	return -2;
}

int detruire_semaphore(void)
{
	if(semaph_ini)//si les smaphores sont crs
	{
		semaph_ini = 0;//mettre la variable globale  0
		return (semctl(semaph_id, 0, IPC_RMID, 0));//dtruire les smaphores
	}
	fprintf(stderr, "Err - Semaphore non initialise\n");//si les smaphores n'existent pas on ne peut les dtruires
	return -1;
}

int val_sem(int sem, int val)
{
	if((semaph_ini)&&(sem<N_SEM)&&(sem>=0))//si le smaphore  modifier existe
	{
		return (semctl(semaph_id, sem, SETVAL, val));//mettre la valeur val dans le semaphore
	}
	fprintf(stderr, "Err - Semaphore non ini ou indice incorrect\n");//si erreur d'accs
	return -1;
}


int P(int sem)
{
	if(!semaph_ini)//si les smaphores ne sont pas crs
	{
		fprintf(stderr, "Err - Semaphore non initialise\n");//erreur
		return -2;
	}
	else
	{
		if((sem<N_SEM)&&(sem>=0))//si le numro de smaphore est correct
		{
			struct sembuf semaph_tab;//structure
			semaph_tab.sem_num = sem;//initialisation
			semaph_tab.sem_op = -1;
			semaph_tab.sem_flg = 0;
			//semaph_tab[sem].sem_op = -1;
			return(semop(semaph_id, &semaph_tab, 1)); 
		}
		fprintf(stderr, "Err - Indice incorrect\n");
		return -1;
	}
	
}

int V(int sem)
{
	if(!semaph_ini)//si les smaphores ne sont pas crs
	{
		fprintf(stderr, "Err - Semaphore non initialise\n");//erreur
		return -2;
	}
	else
	{
		if((sem<N_SEM)&&(sem>=0))//si le numro de smaphore est correct
		{
			struct sembuf semaph_tab;//structure
			semaph_tab.sem_num = sem;
			semaph_tab.sem_op = 1;
			semaph_tab.sem_flg = 0;
			return(semop(semaph_id, &semaph_tab, 1)); 
		}
		fprintf(stderr, "Err - Indice incorrect\n");
		return -1;
	}
	
}

/*
int main()
{
	printf("appel de init :%d\n",init_semaphore());
	printf("appel de init :%d\n",init_semaphore());
	int i;
	scanf("%d",&i);
	printf("appel de val_sem :%d\n",val_sem(i,1));
	printf("appel de P() %d\n",P(i));
	printf("appel de V() %d\n",V(i));
	printf("appel de detruire :%d\n",detruire_semaphore());
	return 0;
}
*/
