#include <termios.h>
#include <unistd.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>



#define NB_CARACTERES 20	// taille de la lignes
#define TIME_TO_WAIT 60000	// temps d'attente
#define TRUE 1
#define FALSE 0


typedef struct termios termios;


/*
	Affiche une chaine de caractère, puis
		- vide le buffer
		- attend quelqueqs millisecondes
*/
void my_printf(char * chaine)
{
	printf(chaine);
	fflush(stdout);
	usleep(TIME_TO_WAIT);
}

void my_printf(char chaine)
{
	printf(chaine);
	fflush(stdout);
	usleep(TIME_TO_WAIT);
}

/*
	affiche les crochets
*/
void prepareAffichage()
{
	int i;
	my_printf("           [");
	for(i=0; i<NB_CARACTERES; i++)
		printf(" ");
	printf("]\b");
	for(i=0; i<NB_CARACTERES; i++)
		printf("\b");
}



void iniTermios(termios * t_save, termios * t_new)
{
	if( tcgetattr(0, &t_save) )
	{
		printf("Erreur de tcgetattr !\n");
		exit(1);
	}

	// initialisation
	t_new = t_save;
	t_new.c_lflag &= (~ICANON & ~ECHO);
	t_new.c_cc[VMIN]= 1;

	tcsetattr(0, TCSANOW, &t_new);
}


int main(int argc, char * argv[])
{
	if (argc != 2)
	{
		printf("Il faut un argument\n");
		exit(1);
	}

	termios t_save, t_new;
	iniTermios(termios &t_save, termios &t_new);
	int j, i;
	for(j=0; j<atoi(argv[1]); j++)
	{
		// affiche les crochets
		prepareAffichage();

		// Allez
		for(i=0; i<NB_CARACTERES; i++)
			my_printf("-");
		printf("]");
		// Retour
		for(i=0; i<NB_CARACTERES; i++)
			my_printf("\b\b ");
		printf("\n");
	}

	return 0;
}
