#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#define TAILLE 5

/* strucure de trois entiers */
typedef struct vector {
	int X;
	int Y;
	int Z;} vector;

/* strucure d'un vecteur et d'une adresse de vecteur */
typedef struct data_vector {
	vector v;
	vector* adr; } data_vector;

/* fonction d'affichage de la structure */
void imprimeVector(vector * v)
{
	if (v)
		printf("%d %d %d\n", v->X, v->Y, v->Z);
	else
		printf("Error...\n");
}


int main()
{
	// allocation d'une zone de mmoire partage
	struct shmid_ds buf;
	int shmid=shmget(ftok("",78), TAILLE*sizeof(data_vector), 0777|IPC_CREAT);
	data_vector * buffer = shmat(shmid, NULL, 0);
	int i=0;
	vector * v[TAILLE];

	// on rempli le buffer
	for(i=0;i<TAILLE;i++)
		v[i] = &buffer[i].v;

	// affichages
	for(i=0;i<TAILLE;i++)
		imprimeVector(v[i]);

	for(i=0;i<TAILLE;i++)
		printf("\t%d", buffer[i].adr);

	printf("\nfin du fichier de lecture\n");
	return 0;
}



