#include "semaph.h"

#define NB_BCL 10000000

/*
Affecter E à une variable A, entre, locale au process.
Attendre entre 20 et 100 ms (Utilisez les fonctions usleep(3) et rand(3V)).
Incrmenter A.
Affecter la variable locale A à la variable "partage" E
*/


int main()
{
	int fils, A, i;
	int * E;
	int shmid;
	srand(getpid());//initialisation d'un nombre alatoire
	shmid = shmget(ftok("/volsme/users/sr02p020/TD1/shrptr.c",78), 1*sizeof(int), 0777|IPC_CREAT);//espace de mmoire partage
	printf("%d\n", shmid);
	E = shmat(shmid, NULL, 0);//on attache le segment de mmoire partage
	printf("%p\n", E);
	*E = 0;
	if((fils = fork()) == -1)//si le fork n as pas fonctionn
	{
		fprintf(stderr, "Erreur du fork\n");//erreur
		exit(1);
	}
	/* On est dans le pere */
	if (fils)
	{
		int statut;
		for(i=0; i<NB_BCL; i++)//faire NB_BCL fois
		{
			A = *E;//A prends E
			usleep( 1000 * (20+(int) (80.0*rand()/(RAND_MAX+1.0))) );//attendre un nombre de secondes alatoire
			A++;//incrmenter A
			*E = A;//remettre A dans E
		}
		printf("fin pere\n");
		wait(&statut);//attendre la fin du fils
		printf("E : %d\n", *E);
		shmctl(shmid, IPC_RMID,0);//dtruire le segment de mmoire partage
	}
	/* On est dans le fils */
	else
	{
		for(i=0; i<NB_BCL; i++)//faire NB_BCL fois
		{
			A = *E;/A prends E
			usleep( 1000 * (20+(int) (80.0*rand()/(RAND_MAX+1.0))));//attendre un nombre de secondes alatoire
			A++;//incrmenter A
			*E = A;//remettre A dans E
		}
		printf("fin fils\n");
	}
	return 0;
}

