#include "semaph.h"

#define NB_BCL 100

/*
Affecter E à une variable A, entière, locale au process.
Attendre entre 20 et 100 ms (Utilisez les fonctions usleep(3) et rand(3V)).
Incrémenter A.
Affecter la variable locale A à la variable "partagée" E
*/


int main()
{
	int fils, A, i;
	int * E;
	int shmid;

	srand(getpid());
	shmid = shmget(ftok("/volsme/users/sr02p020/TD1/shrptr.c",78), 100*sizeof(int), 0777|IPC_CREAT);
	printf("%d\n", shmid);
	E = shmat(shmid, NULL, 0);
	printf("%p\n", E);
	*E = 0;
/* on s'assure que les smaphores sont correctement crs*/
	init_semaphore();
	detruire_semaphore();
	init_semaphore();
	val_sem(2,1);


	if((fils = fork()) == -1)
	{
		fprintf(stderr, "Erreur du fork\n");
		exit(1);
	}

	/* On est dans le pere */
	if (fils)
	{
		int statut;

		for(i=0; i<NB_BCL; i++)
		{
			P(2);
			//printf("pere\n");
			A = *E;
			usleep(100*  (20+(int) (80.0*rand()/(RAND_MAX+1.0))) );
			A++;
			*E = A;
			V(2);
		}
		printf("fin pere\n");
		wait(&statut);
		printf("E : %d\n", *E);
		detruire_semaphore();
		shmctl(shmid, IPC_RMID,0);
	}

	/* On est dans le fils */
	else
	{
		for(i=0; i<NB_BCL; i++)
		{
			P(2);
			//printf("fils\n");
			A = *E;
			usleep(100*  (20+(int) (80.0*rand()/(RAND_MAX+1.0))) );
			A++;
			*E = A;
			V(2);
		}
		printf("fin fils\n");
	}


	return 0;
}

