#include "semaph.h"

//#define NB_BCL 100
#define TAILLE_MEMOIRE 5
#define SEM_PERE 2
#define SEM_FILS 3

int main()
{
	int fils, A, indice=0;
	int * E;
	int shmid;

	srand(getpid());
	shmid = shmget(ftok("/volsme/users/sr02p020/TD1/shrptr.c",78), TAILLE_MEMOIRE*sizeof(int), 0777|IPC_CREAT);
	printf("%d\n", shmid);
	E = shmat(shmid, NULL, 0);
	printf("%p\n", E);
	*E = 0;

	init_semaphore();
	detruire_semaphore();

	init_semaphore();
	val_sem(SEM_PERE,5);
	val_sem(SEM_FILS,0);
/*	
	printf("ok\n");
	V(SEM_FILS);
	printf("ok\n");
	V(SEM_FILS);
	printf("ok\n");
*/
	if((fils = fork()) == -1)
	{
		fprintf(stderr, "Erreur du fork\n");
		exit(1);
	}

	/* On est dans le pere */
	if (fils)
	{
		int statut;
		while(1)
		{
			P(SEM_PERE);
			E[indice] = 1+(int) (49.0*rand()/(RAND_MAX+1.0));
			printf("pere : %d\n", E[indice]);
			indice = (indice+1)%TAILLE_MEMOIRE;
//usleep(100*  (20+(int) (80.0*rand()/(RAND_MAX+1.0))) );
			V(SEM_FILS);
		}
		printf("fin pere\n");
		wait(&statut);
		printf("E : %d\n", *E);
		detruire_semaphore();
		shmctl(shmid, IPC_RMID,0);
	}

	/* On est dans le fils */
	else
	{
		while(1)
		{
			P(SEM_FILS);
			printf("fils : %d\n", E[indice]);
			indice = (indice+1)%TAILLE_MEMOIRE;
usleep(1000*  (20+(int) (80.0*rand()/(RAND_MAX+1.0))) );
			V(SEM_PERE);
		}
		printf("fin fils\n");
	}


	return 0;
}

