/* exemple asywrit.c -- UV SR02  2005 */
#include <stdio.h>
/* solaris #include <sys/asynch.h> */
#include <aio.h>    /* async i/o sur linux */
#include <stdlib.h> /* EXIT_FAILURE */
#include <errno.h>  /* EINPROGRESS */
#include <string.h>

/* gcc -o asywrit asywrit.c -lrt  
  ("rt"= ancien nom de la lib posix conservé pour compat) */
/* [sr02@capella async]$ grep _POSIX_ASYNCHRONOUS_IO /usr/include/unistd.h 
   _POSIX_ASYNCHRONOUS_IO       Asynchronous I/O is supported.                      */

#define Size 40
#define NN 1000
#define Bufsize Size * NN

main ()
{ 
  int i=0, j=0, lng=40;
  char buf[Size]="-0123456789 abcdefghijklmnopqrstuvwxyz=\n";
  char buffer[Bufsize];
  
  struct aiocb *cb;
  int iret, fd;

  for (i=0; i<NN; i++) {  /* préparer un gros buffer de données */
     j=i*Size; 
     memcpy(&buffer[j], buf, Size);
  }

  fd = open("testfile", O_RDWR | O_CREAT | O_SYNC, 0600);
  if (fd < 0) exit(EXIT_FAILURE);

    cb = malloc(sizeof(*cb));
    if (cb == NULL) exit(EXIT_FAILURE);
    memset(cb, 0, sizeof(*cb));
    cb->aio_fildes = fd;
    cb->aio_buf    = buffer;
    cb->aio_nbytes = Bufsize;

  iret = aio_write(cb);
  if (iret != 0) exit(EXIT_FAILURE);

/* As long as the synchronization has not happened, a call to aio_error 
with the reference to the object pointed to by aiocbp returns EINPROGRESS. */
  i = 0;
  while ((iret = aio_error(cb)) == EINPROGRESS) {
  	i++; printf("+"); }
  if (iret != 0) exit(EXIT_FAILURE);
  printf("write fini: iret=%d i=%d\n",iret,i);

} 

/**

	aio_sigevent	* sigev_notify
			* sigev_signo  -> SIGIO

*/
