#include <stdio.h>
#include <string.h>
#include <time.h>


#define maxsize 5000
double A[maxsize][maxsize], X[maxsize], Y[maxsize], S,D;
double B[maxsize][maxsize], C[maxsize][maxsize];


void affiche(int size)
{
	int i=0;
	int j=0;
	for(i=0;i<size;i++)
	{
		for(j=0;j<size;j++)
		{
			printf("%d ", (int)C[i][j]);
		}
		printf("\n");
	}
}




void initaxy(int size)
{
	int i, j;
	for (i=0;i<size;i++)
	{
		for(j=0;j<size;j++)
		{
			A[i][j]=(double) (i+j);
			B[i][j]=(double) (i+j);
			C[i][j]=0;
		}
	}
}


void mulabc(int size)
{
	int i=0;
	int j=0;
	double res;
	int k;
	for(i=0;i<size;i++)
	{
		for(j=0;j<size;j++)
			X[j] = B[i][j];
		for(j=0;j<size;j++)
		{
			res = 0;			
			for (k=0;k<size;k++)
				res +=( A[k][j] * X[k]);
			C[i][j] = res;  
		}
	}
}
void sumdiac(int size)
{
	int i=0;
	double res = 0;
	for(;i<size;i++)
	{
		res += C[i][i];
	}
	//printf("Somme : %d\n", (int)res);
}


int main()
{
	int res;
	clock_t deb, fin;
	scanf("%d", &res);
	initaxy(res);
	deb = clock();
	mulabc(res);
	fin = clock();
	//affiche(res);
	sumdiac(res);
	printf("temps : %d\n", (int)((2*res*res*res)/(fin-deb)));
	return 0;
}
