#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/uio.h>
#include <errno.h>

#define FICHIER "./math.dat"
#define maxsize 5000

double A[maxsize][maxsize], X[maxsize], Y[maxsize], S,D;
double B[maxsize][maxsize], C[maxsize][maxsize];

void initaxy(int size)
{
	int i, j;
	for (i=0;i<size;i++)
	{
		for(j=0;j<size;j++)
		{
			A[i][j]=(double) (i+j);
			B[i][j]=(double) (i+j);
			C[i][j]=0;
		}
	}
}
void wrscat(int size)
 {
         int j,i,fd;
         struct  iovec iov[size];
         fd=open (FICHIER,O_WRONLY|O_CREAT,0666);
         if (fd==-1) perror("open");
         for (i=0;i<size;i++)
         {
                 for (j=0;j<size;j++) 
                 {                       
                         iov[j].iov_len=sizeof(double);  
                         iov[j].iov_base=(void*)&A[j][i];
                         printf("A[%d][%d]=%f\n",i,j,A[j][i]);
               }
               writev(fd, iov, size);
        }
         close(fd);
}       

void rdscat(int size)
{
        int j,i,fd;
        struct  iovec iov[size];
        fd=open (FICHIER,O_RDONLY,0666);
        for (i=0;i<size;i++)
        {
                for (j=0;j<size;j++) 
                {       
                        iov[j].iov_len=sizeof(double);
                        iov[j].iov_base=(void*)&C[i][j];
                }
                readv(fd, iov, size);
        }
        close(fd);
}  

void diffbc(int size)
{
	int i,j;
	double somme = 0;
	for (i=0;i<size;i++)
        {
                for (j=0;j<size;j++) 
                {
			somme+=(B[i][j]-C[i][j]);
		}
	}
	if(somme) 
		printf("Les valeurs diffèrent\n");
        else
		printf("Correct !!\n");
}			

int main()
{
	initaxy(30);
	wrscat(30);
	rdscat(30);
	diffbc(30);
	return 0;
}
