/* tstmenu3.c    */                      /*I*/
/* exemple toolkit GTK (barre de menus + sous-menu +
 * deuxime barre de menu dtachable ) */	/*i*/
/* UTC UV SR01 - (c) Michel.Vayssade@utc.fr oct 2003
 * compil:
gcc pfc1.c -o pfc1 `gtk-config --cflags --libs`
 */

#include <strings.h>
#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>

#define OPEN_F  	1
#define QUITTER 	2
#define A_PROPOS	3
#define AAA	4
#define BBB	5
#define CCC	6
#define BBB_A	7 
#define BBB_B	8 


	GtkWidget *window;
	GtkWidget *table;
	GtkWidget *main_vbox;
	GtkWidget *menubar, *menudet;
	GtkWidget *labelJ1, *labelJ2, *labelDraw;
	GtkWidget *button;
	GtkWidget *box1;


/* -------------------- Les fonctions callback ----------------- */


int coupsJoues[1000];
int coups[3][3];
int nbCoupsJoues = 0;

/* renvoi le numro du joueur qui gagne le coup,
	0 en cas d'galit */
int gagne(int j1, int j2)
{
	// MaJ des tableaux
	coupsJoues[nbCoupsJoues++] = j1;
	if(nbCoupsJoues > 1)
		coups[coupsJoues[nbCoupsJoues-1]][j1-1]++;

	printf("----------------\nJ1 : %d, J2 : %d\n", j1, j2);
	if(j1 == j2) return 0;
	if((j1%3)==((j2+1)%3)) return 1;
	return 2;
}


int genNb()
{
	if (nbCoupsJoues<10)
		return 1+(int) (3.0*rand()/(RAND_MAX+1.0));
	else
	{
		int last = coupsJoues[nbCoupsJoues];
		int ind=0;
		if (coups[last-1][ind] < coups[last-1][1])
			ind=1;
		if (coups[last-1][ind] < coups[last-1][2])
			ind=2;
		return (coups[last-1][ind]);
	}	
}


int joue(int gagnant)
{
	char * text;
	int val, decal;
	GtkLabel* label;
	switch(gagnant)
	{
		case 1:
			printf("Joueur J1 gagne\n");
			text = "J1";
			decal = 5;
			label = (GtkLabel*)labelJ1;
			break;

		case 2:
			printf("Joueur J2 gagne\n");
			text = "J2";
			decal = 5;
			label = (GtkLabel*)labelJ2;
			break;

		default:
			printf("Match nul\n");
			text = "Nul";
			decal = 6;
			label = (GtkLabel*)labelDraw;
	}
	char *exText, newText[4], *intText;
	gtk_label_get(label, (char**)&exText);
	intText = exText + decal*sizeof(char);
	val = atoi(intText) + 1;
	sprintf(newText, "%s : %02d", text, val);
	gtk_label_set_text(label, newText);
}



/* stupid basic example callback */
static void print_hello( GtkWidget *w, guint data )
{	g_message ("Hello, World!\n");
}
void open_file( GtkWidget *w, guint data ){
	printf("here is open_file callback\n");
	print_hello(w, data);
}
void aaa( GtkWidget *w, guint data ){
	printf("here is aaa callback\n");
	print_hello(w, data);
}
void bbb( GtkWidget *w, guint data ){                 
	printf("here is bbb callback data=%d\n",data);
}
void ccc( GtkWidget *w, guint data ){
	printf("here is ccc callback\n");
}
void quitter( GtkWidget *w, guint data ){
	printf("here is quitter callback\n");
	gtk_main_quit();
}
void apropos( GtkWidget *w, guint data ){
	printf("here is apropos callback\n");
}


void clbk_button( GtkWidget *w, guint data ){
	printf("here is button callback\n");
}

void callback_B1(GtkWidget *widget, gpointer data) {
	//g_print("%s was pressed\n",(char *) data);
	joue(gagne(1, genNb()));
}

void callback_B2(GtkWidget *widget, gpointer data) {
	//g_print("%s was pressed\n",(char *) data);
	joue(gagne(2, genNb()));
}

void callback_B3(GtkWidget *widget, gpointer data) {
	//g_print("%s was pressed\n",(char *) data);
	joue(gagne(3, genNb()));
}



/* ------------ Les Traitements des entres de menu ------------ */
void TraiteMenu(GtkWidget *w, guint arg)
{
  switch(arg) 
  {
    case OPEN_F:  	open_file(w,arg); break;
    case AAA:  		aaa(w,arg); break;
    case BBB:  		bbb(w,arg); break;
    case CCC:  		ccc(w,arg); break;
    case QUITTER:  	quitter(w,arg); break;
    case A_PROPOS:	apropos(w,arg); break;
    case BBB_A:		bbb(w,arg); break;  
    case BBB_B:		bbb(w,arg); break;  
  }
}

/* --------------- Le tableau des entres de menu -------------- */

static GtkItemFactoryEntry EntreesDetMenu[] = 		/*I*/
{
  {"/_Fichier",               NULL,         NULL,      0,  "<Branch>"},
  /* nom_menu/entre          raccourci     callback    arg   type  */
  {"/Fichier/Menu_AAA ->aaa", "<control>a", TraiteMenu, AAA, "<Item>"},
  {"/Fichier/Menu_BBB ->bbb", "<control>b", TraiteMenu, BBB, "<Item>"},
/* {"/Fichier/Menu_BBB",       "<control>B", NULL,      0, "<Branch>"},*/
{"/Fichier/Menu_BBB/BBB_A","<control><shift>A",TraiteMenu,BBB_A,"<Item>"},
{"/Fichier/Menu_BBB/BBB_B","<control><shift>B",TraiteMenu,BBB_B,"<Item>"},
  { "/Fichier/sep1",          NULL,         NULL,   0, "<Separator>" },
  {"/Fichier/Menu_CCC ->ccc", "<control>C", TraiteMenu, CCC, "<Item>"},

  {"/Fichier/Quitter",        "<control>Q", TraiteMenu, QUITTER, NULL},
  {"/_Aide",                  NULL,         NULL,   0, "<LastBranch>"},
  {"/Aide/_A propos...",   "<control>H", TraiteMenu,A_PROPOS,"<Item>"}
};

static guint NbEntreesDet = sizeof(EntreesDetMenu) / 
                         sizeof(GtkItemFactoryEntry);	/*i*/

/* -------------- fonction de cration des menus --------------- */

GtkWidget *creer_menu_detach(GtkWidget *Fenetre)
{
  GtkWidget *BarreDetachable;
  GtkWidget *DetMenu;
  GtkItemFactory *Fabrique;
  GtkAccelGroup *Raccourcis;

  BarreDetachable = gtk_handle_box_new();

  /* Le groupe de raccourcis de clavier */
  Raccourcis = gtk_accel_group_new();

  /* Cration de la fabrique */
  /* deux fabriques ne doivent pas avoir la mme racine */
  Fabrique = gtk_item_factory_new(GTK_TYPE_MENU_BAR,
                                  "<Main2>",
                                  Raccourcis);
  /* Cration des entres de menus */
  gtk_item_factory_create_items(Fabrique, NbEntreesDet,
                                EntreesDetMenu, NULL);
  gtk_accel_group_attach(Raccourcis, GTK_OBJECT(Fenetre));

  /* On rcupre la barre de menu depuis la fabrique */
  DetMenu = gtk_item_factory_get_widget(Fabrique,
                                          "<Main2>");

  gtk_container_add(GTK_CONTAINER(BarreDetachable), DetMenu);

  return BarreDetachable;
}


/* ------------------------------ main ------------------------ */


int main(int argc, char *argv[]) {
	/* Initialisation de GTK */
	gtk_init(&argc, &argv);
	/* Cration de la fenetre graphique */
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	/* Gere l'evenement pour quitter l'application */
	gtk_signal_connect(GTK_OBJECT(window), "destroy",
		GTK_SIGNAL_FUNC(gtk_main_quit),
		"WM destroy");
	gtk_window_set_title(GTK_WINDOW(window), "tdgtk  jm et Guillou");
	gtk_widget_set_usize(GTK_WIDGET(window), 400, 350);

	main_vbox = gtk_vbox_new (FALSE, 1);
	gtk_container_border_width (GTK_CONTAINER(main_vbox), 0);
	gtk_container_add (GTK_CONTAINER(window), main_vbox);

	/* Attache un menu a la fenetre principale */
	menudet = creer_menu_detach (main_vbox);
	gtk_box_pack_start (GTK_BOX(main_vbox), menudet, FALSE, FALSE, 1);

	/* On cr un container dans la fenetre pour placer les composants */
	table = gtk_table_new (6, 2, TRUE);
	gtk_container_add(GTK_CONTAINER(main_vbox), table);

	/* Creation d'un label */
	labelJ1 = gtk_label_new("");
	gtk_table_attach_defaults (GTK_TABLE(table), labelJ1, 0, 2, 0, 1);
	gtk_widget_show (labelJ1);
	/* Creation d'un label */
	labelDraw = gtk_label_new("");
	gtk_table_attach_defaults (GTK_TABLE(table), labelDraw, 2, 4, 0, 1);
	gtk_widget_show (labelDraw);
	/* Creation d'un label */
	labelJ2 = gtk_label_new("");
	gtk_table_attach_defaults (GTK_TABLE(table), labelJ2, 4, 6, 0, 1);
	gtk_widget_show (labelJ2);

	/* Creation d'un bouton */
	button = gtk_button_new_with_label ("Pierre");
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
		GTK_SIGNAL_FUNC (callback_B1),
		(gpointer) "Pierre");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 0, 2, 1, 2);
	gtk_widget_show (button);


	/* Creation d'un bouton */
	button = gtk_button_new_with_label ("Feuille");
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
		GTK_SIGNAL_FUNC (callback_B2),
		(gpointer) "Feuille");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 2, 4, 1, 2);
	gtk_widget_show (button);


	/* Creation d'un bouton */
	button = gtk_button_new_with_label ("Ciseaux");
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
		GTK_SIGNAL_FUNC (callback_B3),
		(gpointer) "Ciseaux");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 4, 6, 1, 2);
	gtk_widget_show (button);

	gtk_widget_show(table);
	gtk_box_pack_end (GTK_BOX(main_vbox), table, FALSE, TRUE, 1);
	gtk_widget_show_all(window);
	gtk_main(); 
	return(0);
}



